LeetCode 368 - Largest Divisible Subset


https://leetcode.com/problems/largest-divisible-subset/
Given a set of distinct positive integers, find the largest subset such that every pair (Si, Sj) of elements in this subset satisfies: Si % Sj = 0 or Sj % Si = 0.
If there are multiple solutions, return any subset is fine.
Example 1:
nums: [1,2,3]

Result: [1,2] (of course, [1,3] will also be ok)
Example 2:
nums: [1,2,4,8]

Result: [1,2,4,8]
https://www.hrwhisper.me/leetcode-largest-divisible-subset/
https://segmentfault.com/a/1190000005922634
和LIS很相似,dp[i]表示nums数组从0到i的最大集合的size.
这题应该分成两个问题:
  1. 得到最大集合size
  2. 输出这个集合
对于第一个问题,最大集合size就是dp数组的最大值,可以边画表边维护一个当前最大值;
对于第二个问题,我们要维护一个parent数组,记录nums[i]加入到了哪个集合;
dp[i] = max(dp[i], dp[j] + 1), where 0<=j<i

注意

注意这个case:
[1,2,4,8,9,72]
到72的时候,往前找到9,可以整除,更新dp[5]为max(1, 2 + 1) = 3,
注意此时应该继续往前找,不能停,直到找到8,发现dp[3] + 1 = 5 > 3,于是更新dp[i]
注意就是不能停,找到一个能整除并不够,前面有可能有更大的啊~~
https://discuss.leetcode.com/topic/49652/classic-dp-solution-similar-to-lis-o-n-2
    public List<Integer> largestDivisibleSubset(int[] nums) {
        int n = nums.length;
        int[] count = new int[n];
        int[] pre = new int[n];
        Arrays.sort(nums);
        int max = 0, index = -1;
        for (int i = 0; i < n; i++) {
            count[i] = 1;
            pre[i] = -1;
            for (int j = i - 1; j >= 0; j--) {
                if (nums[i] % nums[j] == 0) {
                    if (1 + count[j] > count[i]) {
                        count[i] = count[j] + 1;
                        pre[i] = j;
                    }
                }
            }
            if (count[i] > max) {
                max = count[i];
                index = i;
            }
        }
        List<Integer> res = new ArrayList<>();
        while (index != -1) {
            res.add(nums[index]);
            index = pre[index];
        }
        return res;
    }
https://discuss.leetcode.com/topic/49424/java-solution-in-32ms-o-n-2-time-o-n-space
http://www.bingfengsa.com/article/7kLzV8O
题意:给定一个数组,求其中的一个最大子集,要求该子集中任意的两个元素满足 x % y ==0 或者 y % x==0
思路:其实和求最大上升子序列LIS差不多,只不过这题要求输出序列而已。
先把数组排好序。首先要明确,若a<b且b%a==0 ,  b <c 且 c%b==0那么必然有c%a==0
我们设dp[i] 为最大的子集长度,更新的时候保存上一个的下标即可。
    public List<Integer> largestDivisibleSubset(int[] nums) {
        List<Integer> ans = new ArrayList<Integer>();
        if (nums.length == 0) return ans;
        Arrays.sort(nums);
        int n = nums.length;
        int[] dp = new int[n], index = new int[n];
        Arrays.fill(dp, 1);
        Arrays.fill(index, -1);
        int max_index = 0, max_dp = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (nums[i] % nums[j] == 0 && dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    index[i] = j;
                }
            }
            if (max_dp < dp[i]) {
                max_dp = dp[i];
                max_index = i;
            }
        }
        for (int i = max_index; i != -1; i = index[i])
            ans.add(nums[i]);
        return ans;
    }

https://xuezhashuati.blogspot.com/2017/04/lintcode-603-largest-divisible-subset.html
    public List<Integer> largestDivisibleSubset(int[] nums) {        
        int[] f = new int[nums.length];
        int[] lastIndex = new int[nums.length];
        Arrays.sort(nums);
        
        int max = 0;
        int maxIndex = -1;
        
        for (int i = 0; i < nums.length; i++) {
            f[i] = 1;
            lastIndex[i] = -1;
            for (int j = 0; j < i; j++) {
                if (nums[i] % nums[j] == 0 && f[i] < f[j] + 1) {
                    f[i] = f[j] + 1;
                    lastIndex[i] = j;
                }
            }
            if (f[i] > max) {
                max = f[i];
                maxIndex = i;
            }
        }
        
        List<Integer> result = new ArrayList<>();
        while (maxIndex != -1) {
            result.add(nums[maxIndex]);
            maxIndex = lastIndex[maxIndex];
        }
        
        return result;
    }
http://blog.csdn.net/qq508618087/article/details/51767785
思路: 可以用动态规划来解决. 为了使得问题可以转化为子问题, 最好将数组按照降序来排列, 然后当nums[j]%nums[i]==0的时候就可以得到一个状态转移方程dp[i] = max(dp[i], dp[j]+1), 因为数组按照降序排序, 所以nums[i] < nums[j],并且之前能够被nums[j]整除的数, 也必然能够别nums[i]整除, 这就保证了状态转移方程的正确性. 
他还要求找出最大结果, 所以我们还需要记录一下路径, 每一个数字, 我们记录一个第一个能够使其到达最大长度的父结点, 最后回溯一下即可.
https://xuezhashuati.blogspot.com/2017/04/lintcode-603-largest-divisible-subset.html
https://discuss.leetcode.com/topic/49424/java-solution-in-32ms-o-n-2-time-o-n-space
f[i]:以nums[i]作为Largest Divisible Subset的最后一个元素的集合的最大值。
lastIndex[i]:以nums[i]作为Largest Divisible Subset的最后一个元素的集合的上一个元素的index。
    public List<Integer> largestDivisibleSubset(int[] nums) {
        int[] f = new int[nums.length];
        int[] lastIndex = new int[nums.length];
        Arrays.sort(nums);
        
        int max = 0;
        int maxIndex = -1;
        
        for (int i = 0; i < nums.length; i++) {
            f[i] = 1;
            lastIndex[i] = -1;
            for (int j = 0; j < i; j++) {
                if (nums[i] % nums[j] == 0 && f[i] < f[j] + 1) {
                    f[i] = f[j] + 1;
                    lastIndex[i] = j;
                }
            }
            if (f[i] > max) {
                max = f[i];
                maxIndex = i;
            }
        }
        
        List<Integer> result = new ArrayList<>();
        while (maxIndex != -1) {
            result.add(nums[maxIndex]);
            maxIndex = lastIndex[maxIndex];
        }
        
        return result;
    }
The idea is to keep track of the next element in the array that gives the longest streak for each element in the array, then in the end, we find the start of the maximal streak, then start from there and find the rest of elements.
nextIdx is an array keeping track of the next element indexed j for each element at i that gives the longest streak, and maxLength keeps track of the current max length for each element. The core algorithm is: for each element at i, we go from n-1 to i+1 to find the best j, and we link i to jby specifying that nextIdx[i] = j.
After we have iterated every element, we start from the maxIdx, which points to the first element in the longest streak. We add that element to our result, then go to the next element according tonextIdx until we reach the last element in that streak, who will have value 0 in its nextIdx slot.
public List<Integer> largestDivisibleSubset(int[] nums) { if (nums.length == 0) { return new ArrayList<Integer>(); } int[] nextIdx = new int[nums.length]; int[] maxLength = new int[nums.length]; int max = 0, maxIdx = 0; Arrays.sort(nums); for (int i = nums.length - 1; i >= 0; i--) { maxLength[i] = 1; for (int j = nums.length - 1; j > i; j--) { if (nums[j] % nums[i] == 0) { if (maxLength[j] + 1 > maxLength[i]) { maxLength[i] = maxLength[j] + 1; nextIdx[i] = j; if (maxLength[i] > max) { maxIdx = i; } } } } } List<Integer> res = new ArrayList<Integer>(); res.add(nums[maxIdx]); int idx = nextIdx[maxIdx]; while (idx != 0) { res.add(nums[idx]); idx = nextIdx[idx]; } return res; }
utilize the transitivity of divisibility, kind of like " Longest Increasing Subsequence" problem However this one requires you to return the actual subset rather than cardinality of the set, so you need to do some bookkeeping by using another array.
https://leetcode.com/discuss/110927/concise-java-solution-using-dp-hashmap
public List<Integer> largestDivisibleSubset(int[] nums) { if(nums.length == 0) return (new ArrayList<Integer>()); Arrays.sort(nums); Map<Integer, Integer> map = new HashMap<>(); int[] dp = new int[nums.length], dp[0] = 1; int maxV = 1, index = 0; for (int i = 1; i < nums.length; i++) { for (int j = 0; j < i; j++) { if (nums[i] % nums[j] == 0) { if (dp[j] + 1 > dp[i]) { dp[i] = dp[j] + 1; map.put(nums[i], nums[j]); // backward index } if (dp[i] > maxV) { maxV = dp[i]; index = i; } } } } List<Integer> ret = new ArrayList<Integer>(); int key = nums[index]; ret.add(key); while (map.containsKey(key)) { ret.add(map.get(key)); key = map.get(key); } return ret; }
http://bookshadow.com/weblog/2016/06/27/leetcode-largest-divisible-subset/
def largestDivisibleSubset(self, nums): """ :type nums: List[int] :rtype: List[int] """ nums = sorted(nums) size = len(nums) dp = [1] * size pre = [None] * size for x in range(size): for y in range(x): if nums[x] % nums[y] == 0 and dp[y] + 1 > dp[x]: dp[x] = dp[y] + 1 pre[x] = y idx = dp.index(max(dp)) ans = [] while idx is not None: ans += nums[idx], idx = pre[idx] return ans

def largestDivisibleSubset(self, nums): """ :type nums: List[int] :rtype: List[int] """ S = {-1: set()} for x in sorted(nums): S[x] = max((S[d] for d in S if x % d == 0), key=len) | {x} return list(max(S.values(), key=len))

http://www.cnblogs.com/grandyang/p/5625209.html
不过dp数组现在每一项保存一个pair,相当于上面解法中的dp和parent数组揉到一起表示了,然后的不同就是下面的方法是从前往后遍历的,每个数字又要遍历到开头
    vector<int> largestDivisibleSubset(vector<int>& nums) {
        sort(nums.begin(), nums.end());
        vector<int> res;
        vector<pair<int, int>> dp(nums.size());
        int mx = 0, mx_idx = 0;
        for (int i = 0; i < nums.size(); ++i) {
            for (int j = i; j >= 0; --j) {
                if (nums[i] % nums[j] == 0 && dp[i].first < dp[j].first + 1) {
                    dp[i].first = dp[j].first + 1;
                    dp[i].second = j;
                    if (mx < dp[i].first) {
                        mx = dp[i].first;
                        mx_idx = i;
                    }
                }
            }
        }
        for (int i = 0; i < mx; ++i) {
            res.push_back(nums[mx_idx]);
            mx_idx = dp[mx_idx].second;
        }
        return res;
    }


https://discuss.leetcode.com/topic/49455/4-lines-in-python
def largestDivisibleSubset(self, nums):
    S = {-1: set()}
    for x in sorted(nums):
        S[x] = max((S[d] for d in S if x % d == 0), key=len) | {x}
    return list(max(S.values(), key=len))
My S[x] is the largest subset with x as the largest element, i.e., the subset of all divisors of x in the input. With S[-1] = emptysetas useful base case. Since divisibility is transitive, a multiple x of some divisor d is also a multiple of all elements in S[d], so it's not necessary to explicitly test divisibility of x by all elements in S[d]. Testing x % d suffices.
While storing entire subsets isn't super efficient, it's also not that bad. To extend a subset, the new element must be divisible by all elements in it, meaning it must be at least twice as large as the largest element in it. So with the 31-bit integers we have here, the largest possible set has size 31 (containing all powers of 2).
http://dartmooryao.blogspot.com/2016/06/leetcode-368-largest-divisible-subset.html
    public List<Integer> largestDivisibleSubset(int[] nums) {
        if(nums.length==0){ return new ArrayList<>(); }
        Map<Integer, Integer> map = new HashMap<>();
        Arrays.sort(nums);
        int[] count = new int[nums.length];
        Arrays.fill(count, 1);
        int maxLen = 0;
        int maxIdx = 0;
        for(int i=nums.length-1; i>=0; i--){
            for(int j=i+1; j<nums.length; j++){
                if(nums[j]%nums[i]==0){
                    if(count[i] < count[j]+1){
                        count[i] = count[j]+1;
                        map.put(i, j);
                    }
                }
            }
            if(count[i] > maxLen){
                maxLen = count[i];
                maxIdx = i;
            }
        }
      
        List<Integer> result = new ArrayList<>();
        Integer idx = maxIdx;
        while(idx != null){
            result.add(nums[idx]);
            idx = map.get(idx);
        }
        return result;
    }

If we need result sorted:
https://louisyw1.gitbooks.io/leetcode/content/dynamic_programming/largest_divisible_subset.html
        for(int i = 0; i < largest; i++){
            res.insert(res.begin(), nums[last]);
            last = son[last];
        }
for (int i = maxIdx; i >= 0;) { //回溯解集 res.addFirst(nums[i]); i = pre[i]; }

倒过来求这样不用在结果前面插入,从后面开始计算
+
    vector<int> largestDivisibleSubset(vector<int>& nums) {
        sort(nums.begin(), nums.end());

        vector<int> dp(nums.size(), 0);
        vector<int> parent(nums.size(), 0);


        int largest = 0;
        int start = 0;
        for(int i = nums.size() - 1; i >= 0; --i){
            //此处j=i对应着上面将dp初始化为0;从后往前迭加,[1,2,4,5,8],效果为[8]->[4, 8]->[2, 4, 8]->[1,2,4,8]
            for(int j = i; j < nums.size(); j++){
                if(nums[j] % nums[i] == 0 && dp[i] < dp[j] + 1){
                    dp[i] = dp[j] + 1;
                    parent[i] = j;
                }

                if(dp[i] > largest){
                    largest = dp[i];
                    start = i;
                }
            }

        }

        vector<int> res;

        for(int i = 0; i < largest; i++){
            res.push_back(nums[start]);
            start = parent[start];
        }
        return res;
    }
https://discuss.leetcode.com/topic/49563/using-hashmap-o-n-2-time-o-n-space

http://www.geeksforgeeks.org/largest-divisible-subset-array/
simple solution is to generate all subsets of given set. For every generated subset, check if it is divisible or not. Finally print the largest divisible subset.
An efficient solution involves following steps.
  1. Sort all array elements in increasing order. The purpose of sorting is to make sure that all divisors of an element appear before it.
  2. Create an array divCount[] of same size as input array. divCount[i] stores size of divisible subset ending with arr[i] (In sorted array). The minimum value of divCount[i] would be 1.
  3. Traverse all array elements. For every element, find a divisor arr[j] with largest value of divCount[j] and store the value of divCount[i] as divCount[j] + 1.
Time Complexity : O(n2)
Auxiliary Space : O(n)
void findLargest(int arr[], int n)
{
    // We first sort the array so that all divisors
    // of a number are before it.
    sort(arr, arr+n);
    // To store count of divisors of all elements
    vector <int> divCount(n, 1);
    // To store previous divisor in result
    vector <int> prev(n, -1);
    // To store index of largest element in maximum
    // size subset
    int max_ind = 0;
    // In i'th iteration, we find length of chain
    // ending with arr[i]
    for (int i=1; i<n; i++)
    {
        // Consider every smaller element as previous
        // element.
        for (int j=0; j<i; j++)
        {
            if (arr[i]%arr[j] == 0)
            {
                if (divCount[i] < divCount[j] + 1)
                {
                    divCount[i] = divCount[j]+1;
                    prev[i] = j;
                }
            }
        }
        // Update last index of largest subset if size
        // of current subset is more.
        if (divCount[max_ind] < divCount[i])
            max_ind = i;
    }
    // Print result
    int k = max_ind;
    while (k >= 0)
    {
        cout << arr[k] << " ";
        k = prev[k];
    }
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts